---
product: "AG Charts"
title: "Sankey Series"
description: "A Sankey Series visualises movement or change between different items, using nodes and links."
framework: javascript
version: "14.2.0"
related:
    - title: "Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/bar-series/"
    - title: "Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/line-series/"
    - title: "Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/area-series/"
    - title: "Scatter"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/scatter-series/"
    - title: "Bubble"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/bubble-series/"
    - title: "Pie"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/pie-series/"
    - title: "Donut"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/donut-series/"
    - title: "Combination"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/combination-series/"
    - title: "Box Plot"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/box-plot-series/"
    - title: "Candlestick"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/candlestick-series/"
    - title: "OHLC"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/ohlc-series/"
    - title: "Heatmap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/heatmap-series/"
    - title: "Histogram"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/histogram-series/"
    - title: "Nightingale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/nightingale-series/"
    - title: "Radar Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/radar-area-series/"
    - title: "Radar Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/radar-line-series/"
    - title: "Radial Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/radial-bar-series/"
    - title: "Radial Column"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/radial-column-series/"
    - title: "Range Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-area-series/"
    - title: "Range Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-bar-series/"
    - title: "Waterfall"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/waterfall-series/"
    - title: "Sunburst"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/sunburst-series/"
    - title: "Treemap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/treemap-series/"
    - title: "Chord"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/chord-series/"
    - title: "Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/funnel-series/"
    - title: "Cone Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/cone-funnel-series/"
    - title: "Pyramid"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/pyramid-series/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Sankey Series

A Sankey Series visualises movement or change between different items, using nodes and links.

## Simple Sankey

#### Sankey Diagram

```ts
import {
  AgChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgChartOptions = {
  title: {
    text: "UK Power Generation",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Wind", to: "Renewables", size: 79 },
    { from: "Nuclear", to: "Renewables", size: 38 },
    { from: "Biomass", to: "Renewables", size: 14 },
    { from: "Solar", to: "Renewables", size: 13 },
    { from: "Hydro", to: "Renewables", size: 3 },
    { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
    { from: "Coal", to: "Fossil Fuels", size: 3 },
    { from: "Imports", to: "Total", size: 33 },
    { from: "Fossil Fuels", to: "Total", size: 89 },
    { from: "Renewables", to: "Total", size: 147 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (GWh)",
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Sankey Diagram](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/simple-sankey/)

To create a Sankey Series, use the `sankey` series type.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
        },
    ],
}
```

In this configuration:

- `fromKey` defines the start node of each link.
- `toKey` defines the end node of each link.
- `sizeKey` defines the size of each link.

> **Warning**
>
> Circular loops are not allowed in Sankey diagrams, and links forming a circular loop will be removed.

## Node Layout

### Horizontal Alignment

The horizontal placement of the nodes can be customised using the `alignment` property on `node`.

#### Alignment

```ts
import {
  AgCharts,
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgFlowProportionChartOptions = {
  title: {
    text: "Company Revenue",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Employees", to: "Sales", size: 2 },
    { from: "Contractors", to: "Sales", size: 2 },
    { from: "Sales", to: "Revenue", size: 4 },
    { from: "Licenses", to: "Revenue", size: 4 },
    { from: "Revenue", to: "Cost of Sales", size: 1 },
    { from: "Revenue", to: "Profit", size: 7 },
    { from: "Profit", to: "Other Expenses", size: 2 },
    { from: "Profit", to: "Operational Profit", size: 5 },
    { from: "Operational Profit", to: "Shareholders", size: 3 },
    { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (USD millions)",
      node: {
        alignment: "left",
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function alignmentChange(event: Event) {
  const value = (event.target as HTMLInputElement).value as
    | "left"
    | "right"
    | "center"
    | "justify";
  (options.series![0] as AgSankeySeriesOptions).node!.alignment = value;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).alignmentChange = alignmentChange;
}
```

[Live example: Alignment](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                alignment: 'left',
            },
        },
    ],
}
```

There are four values supported:

- `left` moves nodes as far left as possible.
- `right` moves nodes as far right as possible.
- `center` moves nodes as close to the centre as possible.
- `justify` moves nodes as far left as possible, except for the last nodes, which are pushed right.

### Vertical Alignment

The vertical placement of the nodes can be customised using the `verticalAlignment` property on `node`.

#### Vertical alignment

```ts
import {
  AgCharts,
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgFlowProportionChartOptions = {
  title: {
    text: "Company Revenue",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Employees", to: "Sales", size: 2 },
    { from: "Contractors", to: "Sales", size: 2 },
    { from: "Sales", to: "Revenue", size: 4 },
    { from: "Licenses", to: "Revenue", size: 4 },
    { from: "Revenue", to: "Cost of Sales", size: 1 },
    { from: "Revenue", to: "Profit", size: 7 },
    { from: "Profit", to: "Other Expenses", size: 2 },
    { from: "Profit", to: "Operational Profit", size: 5 },
    { from: "Operational Profit", to: "Shareholders", size: 3 },
    { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (USD millions)",
      node: {
        verticalAlignment: "center",
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function verticalAlignChange(event: Event) {
  const verticalAlignment = (event.target as HTMLInputElement).value as
    | "top"
    | "bottom"
    | "center";
  (options.series![0] as AgSankeySeriesOptions).node!.verticalAlignment =
    verticalAlignment;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).verticalAlignChange = verticalAlignChange;
}
```

[Live example: Vertical alignment](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/vertical-alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                verticalAlignment: 'top',
            },
        },
    ],
}
```

There are three values supported:

- `top` moves nodes as far up as possible.
- `bottom` moves nodes as far down as possible.
- `center` places the nodes in the middle and distributes evenly in each direction.

### Sorting

The order of the nodes can be customised using the `sort` property on `node`.

#### Sorting

```ts
import {
  AgCharts,
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgFlowProportionChartOptions = {
  title: {
    text: "Company Revenue",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Footwear", to: "North America", size: 2245 },
    { from: "Footwear", to: "Europe, Middle East & Africa", size: 1419 },
    { from: "Footwear", to: "Asia Pacific & Latin America", size: 879 },
    { from: "Footwear", to: "Greater China", size: 1022 },
    { from: "Apparel", to: "North America", size: 1405 },
    { from: "Apparel", to: "Asia Pacific & Latin America", size: 360 },
    { from: "Apparel", to: "Europe, Middle East & Africa", size: 794 },
    { from: "Apparel", to: "Greater China", size: 490 },
    { from: "Equipment", to: "North America", size: 132 },
    { from: "Equipment", to: "Europe, Middle East & Africa", size: 100 },
    { from: "Equipment", to: "Asia Pacific & Latin America", size: 59 },
    { from: "Equipment", to: "Greater China", size: 32 },
    { from: "North America", to: "NIKE Brand", size: 3782 },
    { from: "Europe, Middle East & Africa", to: "NIKE Brand", size: 2313 },
    { from: "Greater China", to: "NIKE Brand", size: 1544 },
    { from: "Asia Pacific & Latin America", to: "NIKE Brand", size: 1298 },
    { from: "Global Brand Divisions", to: "NIKE Brand", size: 9 },
    { from: "NIKE Brand", to: "Revenues", size: 8946 },
    { from: "Converse", to: "Revenues", size: 425 },
    { from: "Corporate", to: "Revenues", size: 3 },
    { from: "Revenues", to: "Cost of sales", size: 5269 },
    { from: "Revenues", to: "Gross profit", size: 4105 },
    {
      from: "Gross profit",
      to: "Selling and administrative expense",
      size: 3142,
    },
    { from: "Gross profit", to: "Interest expense", size: 14 },
    { from: "Gross profit", to: "Income before taxes", size: 949 },
    { from: "Other income", to: "Income before taxes", size: 48 },
    {
      from: "Selling and administrative expense",
      to: "Demand creation expense",
      size: 910,
    },
    {
      from: "Selling and administrative expense",
      to: "Operating overhead expense",
      size: 2232,
    },
    { from: "Income before taxes", to: "Tax expense", size: 150 },
    { from: "Income before taxes", to: "Net income", size: 847 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (USD millions)",
      node: {
        alignment: "center",
        sort: "auto",
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function sortChange(event: Event) {
  const sort = (event.target as HTMLInputElement).value as
    | "data"
    | "ascending"
    | "descending"
    | "auto";
  (options.series![0] as AgSankeySeriesOptions).node!.sort = sort;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).sortChange = sortChange;
}
```

[Live example: Sorting](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/sorting/)

There are three values supported:

- `data` sorts nodes in the same order as they first appear in the `data` array.
- `ascending` and `descending` sort nodes alphanumerically by their displayed labels.
- `auto` sorts nodes to reduce overlapping links and produce a cleaner layout.

## Label Placement

Labels can be placed to the left, right or centred over nodes using the `placement` property.

#### Label Placement

```ts
import {
  AgCharts,
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgFlowProportionChartOptions = {
  title: {
    text: "Company Revenue",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Employees", to: "Sales", size: 2 },
    { from: "Contractors", to: "Sales", size: 2 },
    { from: "Sales", to: "Revenue", size: 4 },
    { from: "Licenses", to: "Revenue", size: 4 },
    { from: "Revenue", to: "Cost of Sales", size: 1 },
    { from: "Revenue", to: "Profit", size: 7 },
    { from: "Profit", to: "Other Expenses", size: 2 },
    { from: "Profit", to: "Operational Profit", size: 5 },
    { from: "Operational Profit", to: "Shareholders", size: 3 },
    { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (USD millions)",
      label: {
        placement: "right",
        edgePlacement: "outside",
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function placementChange(event: Event) {
  const value = (event.target as HTMLInputElement).value as
    | "left"
    | "right"
    | "center";
  (options.series![0] as AgSankeySeriesOptions).label!.placement = value;

  chart.update(options);
}

function edgePlacementChange(event: Event) {
  const value = (event.target as HTMLInputElement).value;
  (options.series![0] as AgSankeySeriesOptions).label!.edgePlacement =
    value === "default" ? undefined : (value as "inside" | "outside");

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).placementChange = placementChange;
  (<any>window).edgePlacementChange = edgePlacementChange;
}
```

[Live example: Label Placement](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/label-placement/)

The optional `edgePlacement` property sets the first and last node labels to `'inside'` or `'outside'`, defaulting to the `placement` value if unspecified.

## Customisation

### Node Style

#### Node Style

```ts
import {
  AgChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgChartOptions = {
  title: {
    text: "UK Power Generation",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Wind", to: "Renewables", size: 79 },
    { from: "Nuclear", to: "Renewables", size: 38 },
    { from: "Biomass", to: "Renewables", size: 14 },
    { from: "Solar", to: "Renewables", size: 13 },
    { from: "Hydro", to: "Renewables", size: 3 },
    { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
    { from: "Coal", to: "Fossil Fuels", size: 3 },
    { from: "Imports", to: "Total", size: 33 },
    { from: "Fossil Fuels", to: "Total", size: 89 },
    { from: "Renewables", to: "Total", size: 147 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (GWh)",
      node: {
        fill: "#34495e",
        stroke: "#2c3e50",
        strokeWidth: 2,
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Node Style](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/node-style/)

The styling of all nodes can be customised using the `node` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                fill: '#34495e',
                stroke: '#2c3e50',
                strokeWidth: 2,
            },
        },
    ],
}
```

### Link Style

#### Link Style

```ts
import {
  AgChartOptions,
  AgCharts,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const options: AgChartOptions = {
  title: {
    text: "UK Power Generation",
  },
  subtitle: {
    text: "2023",
  },
  data: [
    { from: "Wind", to: "Renewables", size: 79 },
    { from: "Nuclear", to: "Renewables", size: 38 },
    { from: "Biomass", to: "Renewables", size: 14 },
    { from: "Solar", to: "Renewables", size: 13 },
    { from: "Hydro", to: "Renewables", size: 3 },
    { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
    { from: "Coal", to: "Fossil Fuels", size: 3 },
    { from: "Imports", to: "Total", size: 33 },
    { from: "Fossil Fuels", to: "Total", size: 89 },
    { from: "Renewables", to: "Total", size: 147 },
  ],
  series: [
    {
      type: "sankey",
      fromKey: "from",
      toKey: "to",
      sizeKey: "size",
      sizeName: "Total (GWh)",
      link: {
        fill: "#34495e",
        fillOpacity: 0.25,
        stroke: "#2c3e50",
        strokeWidth: 1,
        strokeOpacity: 0.25,
      },
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Link Style](https://www.ag-grid.com/charts/archive/14.2.0/typescript/sankey-series/examples/link-style/)

The styling of all links can be customised using the `link` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            link: {
                fill: '#34495e',
                fillOpacity: 0.25,
                stroke: '#2c3e50',
                strokeWidth: 1,
                strokeOpacity: 0.25,
            },
        },
    ],
}
```

## Sankey Chart Examples

See more Sankey Chart examples in the [AG Charts Gallery](https://www.ag-grid.com/charts/archive/14.2.0/gallery/#sankey).

- [Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey/)
- [Customised Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey-customisation/)

## API Reference

#### Sankey Series

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| type (required) | 'sankey' |  | Configuration for the Sankey Series. |
| getItemId | Function |  | A callback to provide a stable identifier for each node, exposed as `itemId` in events and active state.  The returned identifier must be unique across nodes and links, which share one `itemId` namespace (links default to `link-<index>`).  If not supplied, the node name is used as its identifier. |
| id | string | auto-generated value | Primary identifier for the series. This is provided as `seriesId` in user callbacks to differentiate multiple series. Auto-generated ids are subject to future change without warning, if your callbacks need to vary behaviour by series please supply your own unique `id` value. |
| context | ContextDefault |  | Context object to use in callbacks. |
| data | DatumDefault[] |  | The data to use when rendering the series. If this is not supplied, data must be set on the chart instead. |
| visible | boolean |  | Whether to display the series. |
| cursor | string |  | The cursor to use for hovered markers. This config is identical to the CSS `cursor` property. |
| highlight | AgHighlightOptions |  | Configuration for highlighting when a series or legend item is hovered over. |
| highlight.enabled | boolean |  | Set to `false` to disable highlighting. |
| highlight.highlightedItem | AgHighlightStyleOptions |  | Options for the highlighted item. |
| highlight.highlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.highlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.highlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.highlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.highlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.highlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.highlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.highlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| highlight.unhighlightedItem | AgHighlightStyleOptions |  | Options for the un-highlighted items when there is an active highlight. |
| highlight.unhighlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.unhighlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.unhighlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.unhighlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.unhighlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.unhighlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.unhighlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.unhighlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| nodeClickRange | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a node that a click triggers the listener. |
| showInLegend | boolean |  | Whether to include the series in the legend. |
| listeners | AgSeriesListeners |  | A map of event names to event listeners. |
| listeners.seriesNodeClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is clicked. |
| listeners.seriesNodeDoubleClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is double-clicked. |
| fromKey | string |  | The key containing the start node of each link. |
| toKey | string |  | The key containing the end node of each link. |
| sizeKey | string |  | The key containing the size of each link. |
| sizeName | string |  | A human-readable description of the size values. If supplied, this will be shown in the default tooltip and passed to the tooltip renderer as one of the parameters. |
| label | AgSankeySeriesLabelOptions |  | Options for the label for each node. |
| label.spacing | PixelSize |  | Spacing between a node and its label. |
| label.placement | 'left' \| 'right' \| 'center' |  | Placement of a label relative to its node. |
| label.edgePlacement | 'inside' \| 'outside' |  | Placement of an edge label relative to its node. |
| label.formatter | RichFormatter |  | A custom formatting function used to convert data values into text for display by labels. |
| label.format | string |  | Format string used when rendering labels. |
| label.itemStyler | Styler |  | Function used to style individual datum labels. |
| label.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.color | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for text elements. A colour string, or a theme-colour reference object. |
| label.fontSize | FontSize |  | The size of the font in pixels for text elements. |
| label.fontFamily | FontFamily |  | The font family for text elements. |
| label.fontStyle | FontStyle |  | The style to use for text elements. |
| label.fontWeight | FontWeight |  | The font weight to use for text elements. |
| label.border | BorderOptions |  | Stroke options for the box border. |
| label.border.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.border.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| label.border.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| label.border.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| label.cornerRadius | PixelSize |  | Apply rounded corners to the label box. |
| label.padding | PixelSize \| PaddingOptions |  | Distance between the label text and the border. A number applies uniform padding; an object sets each side. |
| label.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| label.fillOpacity | Opacity |  | The opacity of the fill colour. |
| fills | Array<CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill> |  | The colours to cycle through for the fills of the nodes and links. An array of colour strings, or fill objects for gradients, patterns, or images. |
| strokes | CssColor[] |  | The colours to cycle through for the strokes of the nodes and links. |
| link | AgSankeySeriesLinkOptions |  | Options for the links. |
| link.itemStyler | Styler |  | Function used to return formatting for individual links, based on the given parameters. |
| link.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| link.fillOpacity | Opacity |  | The opacity of the fill colour. |
| link.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| link.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| link.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| link.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| link.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| node | AgSankeySeriesNodeOptions |  | Options for the nodes. |
| node.spacing | PixelSize | 20 | Spacing between the nodes. |
| node.minSpacing | PixelSize | 0 | Minimum spacing between the nodes when the series area is reduced in height. |
| node.width | PixelSize | 1 | Width of the nodes. |
| node.cornerRadius | PixelSize | 0 | Rounded corner radius applied to each node, in pixels. |
| node.alignment | 'left' \| 'right' \| 'center' \| 'justify' | 'justify' | Alignment of the nodes. |
| node.verticalAlignment | 'top' \| 'bottom' \| 'center' | 'center' | Vertical alignment of the nodes. |
| node.sort | 'data' \| 'ascending' \| 'descending' \| 'auto' | 'auto' | Sorting method of the nodes. |
| node.itemStyler | Styler |  | Function used to return formatting for individual nodes, based on the given parameters. |
| node.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| node.fillOpacity | Opacity |  | The opacity of the fill colour. |
| node.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| node.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| node.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| node.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| node.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| tooltip | AgSeriesTooltip |  | Series-specific tooltip configuration. |
| tooltip.enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| tooltip.showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| tooltip.range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| tooltip.position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| tooltip.position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| tooltip.position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| tooltip.position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| tooltip.position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| tooltip.position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| tooltip.interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| tooltip.interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| tooltip.renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Sankey Series"
description: "A Sankey Series visualises movement or change between different items, using nodes and links."
framework: angular
version: "14.2.0"
related:
    - title: "Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/bar-series/"
    - title: "Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/line-series/"
    - title: "Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/area-series/"
    - title: "Scatter"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/scatter-series/"
    - title: "Bubble"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/bubble-series/"
    - title: "Pie"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/pie-series/"
    - title: "Donut"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/donut-series/"
    - title: "Combination"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/combination-series/"
    - title: "Box Plot"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/box-plot-series/"
    - title: "Candlestick"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/candlestick-series/"
    - title: "OHLC"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/ohlc-series/"
    - title: "Heatmap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/heatmap-series/"
    - title: "Histogram"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/histogram-series/"
    - title: "Nightingale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/nightingale-series/"
    - title: "Radar Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/radar-area-series/"
    - title: "Radar Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/radar-line-series/"
    - title: "Radial Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/radial-bar-series/"
    - title: "Radial Column"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/radial-column-series/"
    - title: "Range Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-area-series/"
    - title: "Range Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/range-bar-series/"
    - title: "Waterfall"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/waterfall-series/"
    - title: "Sunburst"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/sunburst-series/"
    - title: "Treemap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/treemap-series/"
    - title: "Chord"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/chord-series/"
    - title: "Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/funnel-series/"
    - title: "Cone Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/cone-funnel-series/"
    - title: "Pyramid"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/pyramid-series/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Sankey Series

A Sankey Series visualises movement or change between different items, using nodes and links.

## Simple Sankey

#### Sankey Diagram

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Sankey Diagram](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/simple-sankey/)

To create a Sankey Series, use the `sankey` series type.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
        },
    ],
}
```

In this configuration:

- `fromKey` defines the start node of each link.
- `toKey` defines the end node of each link.
- `sizeKey` defines the size of each link.

> **Warning**
>
> Circular loops are not allowed in Sankey diagrams, and links forming a circular loop will be removed.

## Node Layout

### Horizontal Alignment

The horizontal placement of the nodes can be customised using the `alignment` property on `node`.

#### Alignment

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Alignment](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                alignment: 'left',
            },
        },
    ],
}
```

There are four values supported:

- `left` moves nodes as far left as possible.
- `right` moves nodes as far right as possible.
- `center` moves nodes as close to the centre as possible.
- `justify` moves nodes as far left as possible, except for the last nodes, which are pushed right.

### Vertical Alignment

The vertical placement of the nodes can be customised using the `verticalAlignment` property on `node`.

#### Vertical alignment

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Vertical alignment](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/vertical-alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                verticalAlignment: 'top',
            },
        },
    ],
}
```

There are three values supported:

- `top` moves nodes as far up as possible.
- `bottom` moves nodes as far down as possible.
- `center` places the nodes in the middle and distributes evenly in each direction.

### Sorting

The order of the nodes can be customised using the `sort` property on `node`.

#### Sorting

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Sorting](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/sorting/)

There are three values supported:

- `data` sorts nodes in the same order as they first appear in the `data` array.
- `ascending` and `descending` sort nodes alphanumerically by their displayed labels.
- `auto` sorts nodes to reduce overlapping links and produce a cleaner layout.

## Label Placement

Labels can be placed to the left, right or centred over nodes using the `placement` property.

#### Label Placement

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Label Placement](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/label-placement/)

The optional `edgePlacement` property sets the first and last node labels to `'inside'` or `'outside'`, defaulting to the `placement` value if unspecified.

## Customisation

### Node Style

#### Node Style

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Node Style](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/node-style/)

The styling of all nodes can be customised using the `node` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                fill: '#34495e',
                stroke: '#2c3e50',
                strokeWidth: 2,
            },
        },
    ],
}
```

### Link Style

#### Link Style

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Link Style](https://www.ag-grid.com/charts/archive/14.2.0/angular/sankey-series/examples/link-style/)

The styling of all links can be customised using the `link` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            link: {
                fill: '#34495e',
                fillOpacity: 0.25,
                stroke: '#2c3e50',
                strokeWidth: 1,
                strokeOpacity: 0.25,
            },
        },
    ],
}
```

## Sankey Chart Examples

See more Sankey Chart examples in the [AG Charts Gallery](https://www.ag-grid.com/charts/archive/14.2.0/gallery/#sankey).

- [Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey/)
- [Customised Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey-customisation/)

## API Reference

#### Sankey Series

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| type (required) | 'sankey' |  | Configuration for the Sankey Series. |
| getItemId | Function |  | A callback to provide a stable identifier for each node, exposed as `itemId` in events and active state.  The returned identifier must be unique across nodes and links, which share one `itemId` namespace (links default to `link-<index>`).  If not supplied, the node name is used as its identifier. |
| id | string | auto-generated value | Primary identifier for the series. This is provided as `seriesId` in user callbacks to differentiate multiple series. Auto-generated ids are subject to future change without warning, if your callbacks need to vary behaviour by series please supply your own unique `id` value. |
| context | ContextDefault |  | Context object to use in callbacks. |
| data | DatumDefault[] |  | The data to use when rendering the series. If this is not supplied, data must be set on the chart instead. |
| visible | boolean |  | Whether to display the series. |
| cursor | string |  | The cursor to use for hovered markers. This config is identical to the CSS `cursor` property. |
| highlight | AgHighlightOptions |  | Configuration for highlighting when a series or legend item is hovered over. |
| highlight.enabled | boolean |  | Set to `false` to disable highlighting. |
| highlight.highlightedItem | AgHighlightStyleOptions |  | Options for the highlighted item. |
| highlight.highlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.highlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.highlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.highlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.highlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.highlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.highlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.highlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| highlight.unhighlightedItem | AgHighlightStyleOptions |  | Options for the un-highlighted items when there is an active highlight. |
| highlight.unhighlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.unhighlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.unhighlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.unhighlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.unhighlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.unhighlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.unhighlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.unhighlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| nodeClickRange | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a node that a click triggers the listener. |
| showInLegend | boolean |  | Whether to include the series in the legend. |
| listeners | AgSeriesListeners |  | A map of event names to event listeners. |
| listeners.seriesNodeClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is clicked. |
| listeners.seriesNodeDoubleClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is double-clicked. |
| fromKey | string |  | The key containing the start node of each link. |
| toKey | string |  | The key containing the end node of each link. |
| sizeKey | string |  | The key containing the size of each link. |
| sizeName | string |  | A human-readable description of the size values. If supplied, this will be shown in the default tooltip and passed to the tooltip renderer as one of the parameters. |
| label | AgSankeySeriesLabelOptions |  | Options for the label for each node. |
| label.spacing | PixelSize |  | Spacing between a node and its label. |
| label.placement | 'left' \| 'right' \| 'center' |  | Placement of a label relative to its node. |
| label.edgePlacement | 'inside' \| 'outside' |  | Placement of an edge label relative to its node. |
| label.formatter | RichFormatter |  | A custom formatting function used to convert data values into text for display by labels. |
| label.format | string |  | Format string used when rendering labels. |
| label.itemStyler | Styler |  | Function used to style individual datum labels. |
| label.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.color | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for text elements. A colour string, or a theme-colour reference object. |
| label.fontSize | FontSize |  | The size of the font in pixels for text elements. |
| label.fontFamily | FontFamily |  | The font family for text elements. |
| label.fontStyle | FontStyle |  | The style to use for text elements. |
| label.fontWeight | FontWeight |  | The font weight to use for text elements. |
| label.border | BorderOptions |  | Stroke options for the box border. |
| label.border.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.border.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| label.border.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| label.border.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| label.cornerRadius | PixelSize |  | Apply rounded corners to the label box. |
| label.padding | PixelSize \| PaddingOptions |  | Distance between the label text and the border. A number applies uniform padding; an object sets each side. |
| label.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| label.fillOpacity | Opacity |  | The opacity of the fill colour. |
| fills | Array<CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill> |  | The colours to cycle through for the fills of the nodes and links. An array of colour strings, or fill objects for gradients, patterns, or images. |
| strokes | CssColor[] |  | The colours to cycle through for the strokes of the nodes and links. |
| link | AgSankeySeriesLinkOptions |  | Options for the links. |
| link.itemStyler | Styler |  | Function used to return formatting for individual links, based on the given parameters. |
| link.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| link.fillOpacity | Opacity |  | The opacity of the fill colour. |
| link.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| link.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| link.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| link.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| link.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| node | AgSankeySeriesNodeOptions |  | Options for the nodes. |
| node.spacing | PixelSize | 20 | Spacing between the nodes. |
| node.minSpacing | PixelSize | 0 | Minimum spacing between the nodes when the series area is reduced in height. |
| node.width | PixelSize | 1 | Width of the nodes. |
| node.cornerRadius | PixelSize | 0 | Rounded corner radius applied to each node, in pixels. |
| node.alignment | 'left' \| 'right' \| 'center' \| 'justify' | 'justify' | Alignment of the nodes. |
| node.verticalAlignment | 'top' \| 'bottom' \| 'center' | 'center' | Vertical alignment of the nodes. |
| node.sort | 'data' \| 'ascending' \| 'descending' \| 'auto' | 'auto' | Sorting method of the nodes. |
| node.itemStyler | Styler |  | Function used to return formatting for individual nodes, based on the given parameters. |
| node.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| node.fillOpacity | Opacity |  | The opacity of the fill colour. |
| node.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| node.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| node.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| node.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| node.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| tooltip | AgSeriesTooltip |  | Series-specific tooltip configuration. |
| tooltip.enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| tooltip.showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| tooltip.range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| tooltip.position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| tooltip.position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| tooltip.position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| tooltip.position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| tooltip.position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| tooltip.position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| tooltip.interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| tooltip.interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| tooltip.renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Sankey Series"
description: "A Sankey Series visualises movement or change between different items, using nodes and links."
framework: vue
version: "14.2.0"
related:
    - title: "Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/bar-series/"
    - title: "Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/line-series/"
    - title: "Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/area-series/"
    - title: "Scatter"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/scatter-series/"
    - title: "Bubble"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/bubble-series/"
    - title: "Pie"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/pie-series/"
    - title: "Donut"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/donut-series/"
    - title: "Combination"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/combination-series/"
    - title: "Box Plot"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/box-plot-series/"
    - title: "Candlestick"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/candlestick-series/"
    - title: "OHLC"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/ohlc-series/"
    - title: "Heatmap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/heatmap-series/"
    - title: "Histogram"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/histogram-series/"
    - title: "Nightingale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/nightingale-series/"
    - title: "Radar Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/radar-area-series/"
    - title: "Radar Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/radar-line-series/"
    - title: "Radial Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/radial-bar-series/"
    - title: "Radial Column"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/radial-column-series/"
    - title: "Range Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-area-series/"
    - title: "Range Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/range-bar-series/"
    - title: "Waterfall"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/waterfall-series/"
    - title: "Sunburst"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/sunburst-series/"
    - title: "Treemap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/treemap-series/"
    - title: "Chord"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/chord-series/"
    - title: "Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/funnel-series/"
    - title: "Cone Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/cone-funnel-series/"
    - title: "Pyramid"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/pyramid-series/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Sankey Series

A Sankey Series visualises movement or change between different items, using nodes and links.

## Simple Sankey

#### Sankey Diagram

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "UK Power Generation",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Wind", to: "Renewables", size: 79 },
        { from: "Nuclear", to: "Renewables", size: 38 },
        { from: "Biomass", to: "Renewables", size: 14 },
        { from: "Solar", to: "Renewables", size: 13 },
        { from: "Hydro", to: "Renewables", size: 3 },
        { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
        { from: "Coal", to: "Fossil Fuels", size: 3 },
        { from: "Imports", to: "Total", size: 33 },
        { from: "Fossil Fuels", to: "Total", size: 89 },
        { from: "Renewables", to: "Total", size: 147 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (GWh)",
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Sankey Diagram](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/simple-sankey/)

To create a Sankey Series, use the `sankey` series type.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
        },
    ],
}
```

In this configuration:

- `fromKey` defines the start node of each link.
- `toKey` defines the end node of each link.
- `sizeKey` defines the size of each link.

> **Warning**
>
> Circular loops are not allowed in Sankey diagrams, and links forming a circular loop will be removed.

## Node Layout

### Horizontal Alignment

The horizontal placement of the nodes can be customised using the `alignment` property on `node`.

#### Alignment

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Alignment">
          <input type="radio" id="alignment-left" name="alignment" value="left" checked="" v-on:change="alignmentChange($event)">
            <label for="alignment-left"><code>'left'</code></label>
            <input type="radio" id="alignment-right" name="alignment" value="right" v-on:change="alignmentChange($event)">
              <label for="alignment-right"><code>'right'</code></label>
              <input type="radio" id="alignment-center" name="alignment" value="center" v-on:change="alignmentChange($event)">
                <label for="alignment-center"><code>'center'</code></label>
                <input type="radio" id="alignment-justify" name="alignment" value="justify" v-on:change="alignmentChange($event)">
                  <label for="alignment-justify"><code>'justify'</code></label>
                </div>
              </div>
            </div>
            <ag-charts
              :options="options"
            />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgFlowProportionChartOptions>({
      title: {
        text: "Company Revenue",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Employees", to: "Sales", size: 2 },
        { from: "Contractors", to: "Sales", size: 2 },
        { from: "Sales", to: "Revenue", size: 4 },
        { from: "Licenses", to: "Revenue", size: 4 },
        { from: "Revenue", to: "Cost of Sales", size: 1 },
        { from: "Revenue", to: "Profit", size: 7 },
        { from: "Profit", to: "Other Expenses", size: 2 },
        { from: "Profit", to: "Operational Profit", size: 5 },
        { from: "Operational Profit", to: "Shareholders", size: 3 },
        { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (USD millions)",
          node: {
            alignment: "left",
          },
        },
      ],
    });

    const alignmentChange = (event) => {
      const optionsCopy = clone(options.value);

      const value = event.target.value;
      optionsCopy.series[0].node.alignment = value;

      options.value = optionsCopy;
    };

    return {
      options,
      alignmentChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Alignment](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                alignment: 'left',
            },
        },
    ],
}
```

There are four values supported:

- `left` moves nodes as far left as possible.
- `right` moves nodes as far right as possible.
- `center` moves nodes as close to the centre as possible.
- `justify` moves nodes as far left as possible, except for the last nodes, which are pushed right.

### Vertical Alignment

The vertical placement of the nodes can be customised using the `verticalAlignment` property on `node`.

#### Vertical alignment

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Vertical Alignment">
          <input type="radio" id="vertical-alignment-top" name="vertical-alignment" value="top" v-on:change="verticalAlignChange($event)">
            <label for="vertical-alignment-top"><code>'top'</code></label>
            <input type="radio" id="vertical-alignment-bottom" name="vertical-alignment" value="bottom" v-on:change="verticalAlignChange($event)">
              <label for="vertical-alignment-bottom"><code>'bottom'</code></label>
              <input type="radio" id="vertical-alignment-center" name="vertical-alignment" value="center" checked="" v-on:change="verticalAlignChange($event)">
                <label for="vertical-alignment-center"><code>'center'</code></label>
              </div>
            </div>
          </div>
          <ag-charts
            :options="options"
          />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgFlowProportionChartOptions>({
      title: {
        text: "Company Revenue",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Employees", to: "Sales", size: 2 },
        { from: "Contractors", to: "Sales", size: 2 },
        { from: "Sales", to: "Revenue", size: 4 },
        { from: "Licenses", to: "Revenue", size: 4 },
        { from: "Revenue", to: "Cost of Sales", size: 1 },
        { from: "Revenue", to: "Profit", size: 7 },
        { from: "Profit", to: "Other Expenses", size: 2 },
        { from: "Profit", to: "Operational Profit", size: 5 },
        { from: "Operational Profit", to: "Shareholders", size: 3 },
        { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (USD millions)",
          node: {
            verticalAlignment: "center",
          },
        },
      ],
    });

    const verticalAlignChange = (event) => {
      const optionsCopy = clone(options.value);

      const verticalAlignment = event.target.value;
      optionsCopy.series[0].node.verticalAlignment = verticalAlignment;

      options.value = optionsCopy;
    };

    return {
      options,
      verticalAlignChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Vertical alignment](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/vertical-alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                verticalAlignment: 'top',
            },
        },
    ],
}
```

There are three values supported:

- `top` moves nodes as far up as possible.
- `bottom` moves nodes as far down as possible.
- `center` places the nodes in the middle and distributes evenly in each direction.

### Sorting

The order of the nodes can be customised using the `sort` property on `node`.

#### Sorting

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Sort">
          <input type="radio" id="sort-data" name="sort" value="data" v-on:change="sortChange($event)">
            <label for="sort-data"><code>'data'</code></label>
            <input type="radio" id="sort-ascending" name="sort" value="ascending" v-on:change="sortChange($event)">
              <label for="sort-ascending"><code>'ascending'</code></label>
              <input type="radio" id="sort-descending" name="sort" value="descending" v-on:change="sortChange($event)">
                <label for="sort-descending"><code>'descending'</code></label>
                <input type="radio" id="sort-auto" name="sort" value="auto" checked="" v-on:change="sortChange($event)">
                  <label for="sort-auto"><code>'auto'</code></label>
                </div>
              </div>
            </div>
            <ag-charts
              :options="options"
            />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgFlowProportionChartOptions>({
      title: {
        text: "Company Revenue",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Footwear", to: "North America", size: 2245 },
        { from: "Footwear", to: "Europe, Middle East & Africa", size: 1419 },
        { from: "Footwear", to: "Asia Pacific & Latin America", size: 879 },
        { from: "Footwear", to: "Greater China", size: 1022 },
        { from: "Apparel", to: "North America", size: 1405 },
        { from: "Apparel", to: "Asia Pacific & Latin America", size: 360 },
        { from: "Apparel", to: "Europe, Middle East & Africa", size: 794 },
        { from: "Apparel", to: "Greater China", size: 490 },
        { from: "Equipment", to: "North America", size: 132 },
        { from: "Equipment", to: "Europe, Middle East & Africa", size: 100 },
        { from: "Equipment", to: "Asia Pacific & Latin America", size: 59 },
        { from: "Equipment", to: "Greater China", size: 32 },
        { from: "North America", to: "NIKE Brand", size: 3782 },
        { from: "Europe, Middle East & Africa", to: "NIKE Brand", size: 2313 },
        { from: "Greater China", to: "NIKE Brand", size: 1544 },
        { from: "Asia Pacific & Latin America", to: "NIKE Brand", size: 1298 },
        { from: "Global Brand Divisions", to: "NIKE Brand", size: 9 },
        { from: "NIKE Brand", to: "Revenues", size: 8946 },
        { from: "Converse", to: "Revenues", size: 425 },
        { from: "Corporate", to: "Revenues", size: 3 },
        { from: "Revenues", to: "Cost of sales", size: 5269 },
        { from: "Revenues", to: "Gross profit", size: 4105 },
        {
          from: "Gross profit",
          to: "Selling and administrative expense",
          size: 3142,
        },
        { from: "Gross profit", to: "Interest expense", size: 14 },
        { from: "Gross profit", to: "Income before taxes", size: 949 },
        { from: "Other income", to: "Income before taxes", size: 48 },
        {
          from: "Selling and administrative expense",
          to: "Demand creation expense",
          size: 910,
        },
        {
          from: "Selling and administrative expense",
          to: "Operating overhead expense",
          size: 2232,
        },
        { from: "Income before taxes", to: "Tax expense", size: 150 },
        { from: "Income before taxes", to: "Net income", size: 847 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (USD millions)",
          node: {
            alignment: "center",
            sort: "auto",
          },
        },
      ],
    });

    const sortChange = (event) => {
      const optionsCopy = clone(options.value);

      const sort = event.target.value;
      optionsCopy.series[0].node.sort = sort;

      options.value = optionsCopy;
    };

    return {
      options,
      sortChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Sorting](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/sorting/)

There are three values supported:

- `data` sorts nodes in the same order as they first appear in the `data` array.
- `ascending` and `descending` sort nodes alphanumerically by their displayed labels.
- `auto` sorts nodes to reduce overlapping links and produce a cleaner layout.

## Label Placement

Labels can be placed to the left, right or centred over nodes using the `placement` property.

#### Label Placement

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span> Placement: </span>
        <div class="button-group gap-right" role="group" aria-label="Placement">
          <input type="radio" id="placement-left" name="placement" value="left" v-on:change="placementChange($event)">
            <label for="placement-left"><code>'left'</code></label>
            <input type="radio" id="placement-right" name="placement" value="right" checked="" v-on:change="placementChange($event)">
              <label for="placement-right"><code>'right'</code></label>
              <input type="radio" id="placement-center" name="placement" value="center" v-on:change="placementChange($event)">
                <label for="placement-center"><code>'center'</code></label>
              </div>
              <span> Edge Placement: </span>
              <div class="button-group" role="group" aria-label="Edge Placement">
                <input type="radio" id="edge-placement-outside" name="edge-placement" value="outside" checked="" v-on:change="edgePlacementChange($event)">
                  <label for="edge-placement-outside"><code>'outside'</code></label>
                  <input type="radio" id="edge-placement-inside" name="edge-placement" value="inside" v-on:change="edgePlacementChange($event)">
                    <label for="edge-placement-inside"><code>'inside'</code></label>
                    <input type="radio" id="edge-placement-default" name="edge-placement" value="default" v-on:change="edgePlacementChange($event)">
                      <label for="edge-placement-default"><code>undefined</code></label>
                    </div>
                  </div>
                </div>
                <ag-charts
                  :options="options"
                />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgFlowProportionChartOptions>({
      title: {
        text: "Company Revenue",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Employees", to: "Sales", size: 2 },
        { from: "Contractors", to: "Sales", size: 2 },
        { from: "Sales", to: "Revenue", size: 4 },
        { from: "Licenses", to: "Revenue", size: 4 },
        { from: "Revenue", to: "Cost of Sales", size: 1 },
        { from: "Revenue", to: "Profit", size: 7 },
        { from: "Profit", to: "Other Expenses", size: 2 },
        { from: "Profit", to: "Operational Profit", size: 5 },
        { from: "Operational Profit", to: "Shareholders", size: 3 },
        { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (USD millions)",
          label: {
            placement: "right",
            edgePlacement: "outside",
          },
        },
      ],
    });

    const placementChange = (event) => {
      const optionsCopy = clone(options.value);

      const value = event.target.value;
      optionsCopy.series[0].label.placement = value;

      options.value = optionsCopy;
    };
    const edgePlacementChange = (event) => {
      const optionsCopy = clone(options.value);

      const value = event.target.value;
      optionsCopy.series[0].label.edgePlacement =
        value === "default" ? undefined : value;

      options.value = optionsCopy;
    };

    return {
      options,
      placementChange,
      edgePlacementChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Label Placement](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/label-placement/)

The optional `edgePlacement` property sets the first and last node labels to `'inside'` or `'outside'`, defaulting to the `placement` value if unspecified.

## Customisation

### Node Style

#### Node Style

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "UK Power Generation",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Wind", to: "Renewables", size: 79 },
        { from: "Nuclear", to: "Renewables", size: 38 },
        { from: "Biomass", to: "Renewables", size: 14 },
        { from: "Solar", to: "Renewables", size: 13 },
        { from: "Hydro", to: "Renewables", size: 3 },
        { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
        { from: "Coal", to: "Fossil Fuels", size: 3 },
        { from: "Imports", to: "Total", size: 33 },
        { from: "Fossil Fuels", to: "Total", size: 89 },
        { from: "Renewables", to: "Total", size: 147 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (GWh)",
          node: {
            fill: "#34495e",
            stroke: "#2c3e50",
            strokeWidth: 2,
          },
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Node Style](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/node-style/)

The styling of all nodes can be customised using the `node` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                fill: '#34495e',
                stroke: '#2c3e50',
                strokeWidth: 2,
            },
        },
    ],
}
```

### Link Style

#### Link Style

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions>({
      title: {
        text: "UK Power Generation",
      },
      subtitle: {
        text: "2023",
      },
      data: [
        { from: "Wind", to: "Renewables", size: 79 },
        { from: "Nuclear", to: "Renewables", size: 38 },
        { from: "Biomass", to: "Renewables", size: 14 },
        { from: "Solar", to: "Renewables", size: 13 },
        { from: "Hydro", to: "Renewables", size: 3 },
        { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
        { from: "Coal", to: "Fossil Fuels", size: 3 },
        { from: "Imports", to: "Total", size: 33 },
        { from: "Fossil Fuels", to: "Total", size: 89 },
        { from: "Renewables", to: "Total", size: 147 },
      ],
      series: [
        {
          type: "sankey",
          fromKey: "from",
          toKey: "to",
          sizeKey: "size",
          sizeName: "Total (GWh)",
          link: {
            fill: "#34495e",
            fillOpacity: 0.25,
            stroke: "#2c3e50",
            strokeWidth: 1,
            strokeOpacity: 0.25,
          },
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Link Style](https://www.ag-grid.com/charts/archive/14.2.0/vue3/sankey-series/examples/link-style/)

The styling of all links can be customised using the `link` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            link: {
                fill: '#34495e',
                fillOpacity: 0.25,
                stroke: '#2c3e50',
                strokeWidth: 1,
                strokeOpacity: 0.25,
            },
        },
    ],
}
```

## Sankey Chart Examples

See more Sankey Chart examples in the [AG Charts Gallery](https://www.ag-grid.com/charts/archive/14.2.0/gallery/#sankey).

- [Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey/)
- [Customised Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey-customisation/)

## API Reference

#### Sankey Series

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| type (required) | 'sankey' |  | Configuration for the Sankey Series. |
| getItemId | Function |  | A callback to provide a stable identifier for each node, exposed as `itemId` in events and active state.  The returned identifier must be unique across nodes and links, which share one `itemId` namespace (links default to `link-<index>`).  If not supplied, the node name is used as its identifier. |
| id | string | auto-generated value | Primary identifier for the series. This is provided as `seriesId` in user callbacks to differentiate multiple series. Auto-generated ids are subject to future change without warning, if your callbacks need to vary behaviour by series please supply your own unique `id` value. |
| context | ContextDefault |  | Context object to use in callbacks. |
| data | DatumDefault[] |  | The data to use when rendering the series. If this is not supplied, data must be set on the chart instead. |
| visible | boolean |  | Whether to display the series. |
| cursor | string |  | The cursor to use for hovered markers. This config is identical to the CSS `cursor` property. |
| highlight | AgHighlightOptions |  | Configuration for highlighting when a series or legend item is hovered over. |
| highlight.enabled | boolean |  | Set to `false` to disable highlighting. |
| highlight.highlightedItem | AgHighlightStyleOptions |  | Options for the highlighted item. |
| highlight.highlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.highlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.highlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.highlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.highlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.highlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.highlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.highlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| highlight.unhighlightedItem | AgHighlightStyleOptions |  | Options for the un-highlighted items when there is an active highlight. |
| highlight.unhighlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.unhighlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.unhighlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.unhighlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.unhighlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.unhighlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.unhighlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.unhighlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| nodeClickRange | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a node that a click triggers the listener. |
| showInLegend | boolean |  | Whether to include the series in the legend. |
| listeners | AgSeriesListeners |  | A map of event names to event listeners. |
| listeners.seriesNodeClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is clicked. |
| listeners.seriesNodeDoubleClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is double-clicked. |
| fromKey | string |  | The key containing the start node of each link. |
| toKey | string |  | The key containing the end node of each link. |
| sizeKey | string |  | The key containing the size of each link. |
| sizeName | string |  | A human-readable description of the size values. If supplied, this will be shown in the default tooltip and passed to the tooltip renderer as one of the parameters. |
| label | AgSankeySeriesLabelOptions |  | Options for the label for each node. |
| label.spacing | PixelSize |  | Spacing between a node and its label. |
| label.placement | 'left' \| 'right' \| 'center' |  | Placement of a label relative to its node. |
| label.edgePlacement | 'inside' \| 'outside' |  | Placement of an edge label relative to its node. |
| label.formatter | RichFormatter |  | A custom formatting function used to convert data values into text for display by labels. |
| label.format | string |  | Format string used when rendering labels. |
| label.itemStyler | Styler |  | Function used to style individual datum labels. |
| label.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.color | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for text elements. A colour string, or a theme-colour reference object. |
| label.fontSize | FontSize |  | The size of the font in pixels for text elements. |
| label.fontFamily | FontFamily |  | The font family for text elements. |
| label.fontStyle | FontStyle |  | The style to use for text elements. |
| label.fontWeight | FontWeight |  | The font weight to use for text elements. |
| label.border | BorderOptions |  | Stroke options for the box border. |
| label.border.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.border.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| label.border.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| label.border.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| label.cornerRadius | PixelSize |  | Apply rounded corners to the label box. |
| label.padding | PixelSize \| PaddingOptions |  | Distance between the label text and the border. A number applies uniform padding; an object sets each side. |
| label.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| label.fillOpacity | Opacity |  | The opacity of the fill colour. |
| fills | Array<CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill> |  | The colours to cycle through for the fills of the nodes and links. An array of colour strings, or fill objects for gradients, patterns, or images. |
| strokes | CssColor[] |  | The colours to cycle through for the strokes of the nodes and links. |
| link | AgSankeySeriesLinkOptions |  | Options for the links. |
| link.itemStyler | Styler |  | Function used to return formatting for individual links, based on the given parameters. |
| link.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| link.fillOpacity | Opacity |  | The opacity of the fill colour. |
| link.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| link.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| link.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| link.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| link.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| node | AgSankeySeriesNodeOptions |  | Options for the nodes. |
| node.spacing | PixelSize | 20 | Spacing between the nodes. |
| node.minSpacing | PixelSize | 0 | Minimum spacing between the nodes when the series area is reduced in height. |
| node.width | PixelSize | 1 | Width of the nodes. |
| node.cornerRadius | PixelSize | 0 | Rounded corner radius applied to each node, in pixels. |
| node.alignment | 'left' \| 'right' \| 'center' \| 'justify' | 'justify' | Alignment of the nodes. |
| node.verticalAlignment | 'top' \| 'bottom' \| 'center' | 'center' | Vertical alignment of the nodes. |
| node.sort | 'data' \| 'ascending' \| 'descending' \| 'auto' | 'auto' | Sorting method of the nodes. |
| node.itemStyler | Styler |  | Function used to return formatting for individual nodes, based on the given parameters. |
| node.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| node.fillOpacity | Opacity |  | The opacity of the fill colour. |
| node.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| node.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| node.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| node.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| node.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| tooltip | AgSeriesTooltip |  | Series-specific tooltip configuration. |
| tooltip.enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| tooltip.showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| tooltip.range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| tooltip.position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| tooltip.position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| tooltip.position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| tooltip.position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| tooltip.position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| tooltip.position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| tooltip.interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| tooltip.interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| tooltip.renderer | Renderer |  | Function used to create the content for tooltips. |


---
product: "AG Charts"
title: "Sankey Series"
description: "A Sankey Series visualises movement or change between different items, using nodes and links."
framework: react
version: "14.2.0"
related:
    - title: "Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/bar-series/"
    - title: "Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/line-series/"
    - title: "Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/area-series/"
    - title: "Scatter"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/scatter-series/"
    - title: "Bubble"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/bubble-series/"
    - title: "Pie"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/pie-series/"
    - title: "Donut"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/donut-series/"
    - title: "Combination"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/combination-series/"
    - title: "Box Plot"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/box-plot-series/"
    - title: "Candlestick"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/candlestick-series/"
    - title: "OHLC"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/ohlc-series/"
    - title: "Heatmap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/heatmap-series/"
    - title: "Histogram"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/histogram-series/"
    - title: "Nightingale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/nightingale-series/"
    - title: "Radar Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/radar-area-series/"
    - title: "Radar Line"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/radar-line-series/"
    - title: "Radial Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/radial-bar-series/"
    - title: "Radial Column"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/radial-column-series/"
    - title: "Range Area"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-area-series/"
    - title: "Range Bar"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/range-bar-series/"
    - title: "Waterfall"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/waterfall-series/"
    - title: "Sunburst"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/sunburst-series/"
    - title: "Treemap"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/treemap-series/"
    - title: "Chord"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/chord-series/"
    - title: "Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/funnel-series/"
    - title: "Cone Funnel"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/cone-funnel-series/"
    - title: "Pyramid"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/pyramid-series/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Sankey Series

A Sankey Series visualises movement or change between different items, using nodes and links.

## Simple Sankey

#### Sankey Diagram

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "UK Power Generation",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Wind", to: "Renewables", size: 79 },
      { from: "Nuclear", to: "Renewables", size: 38 },
      { from: "Biomass", to: "Renewables", size: 14 },
      { from: "Solar", to: "Renewables", size: 13 },
      { from: "Hydro", to: "Renewables", size: 3 },
      { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
      { from: "Coal", to: "Fossil Fuels", size: 3 },
      { from: "Imports", to: "Total", size: 33 },
      { from: "Fossil Fuels", to: "Total", size: 89 },
      { from: "Renewables", to: "Total", size: 147 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (GWh)",
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Sankey Diagram](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/simple-sankey/)

To create a Sankey Series, use the `sankey` series type.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
        },
    ],
}
```

In this configuration:

- `fromKey` defines the start node of each link.
- `toKey` defines the end node of each link.
- `sizeKey` defines the size of each link.

> **Warning**
>
> Circular loops are not allowed in Sankey diagrams, and links forming a circular loop will be removed.

## Node Layout

### Horizontal Alignment

The horizontal placement of the nodes can be customised using the `alignment` property on `node`.

#### Alignment

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFlowProportionChartOptions>({
    title: {
      text: "Company Revenue",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Employees", to: "Sales", size: 2 },
      { from: "Contractors", to: "Sales", size: 2 },
      { from: "Sales", to: "Revenue", size: 4 },
      { from: "Licenses", to: "Revenue", size: 4 },
      { from: "Revenue", to: "Cost of Sales", size: 1 },
      { from: "Revenue", to: "Profit", size: 7 },
      { from: "Profit", to: "Other Expenses", size: 2 },
      { from: "Profit", to: "Operational Profit", size: 5 },
      { from: "Operational Profit", to: "Shareholders", size: 3 },
      { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (USD millions)",
        node: {
          alignment: "left",
        },
      },
    ],
  });

  const alignmentChange = (event: Event) => {
    const nextOptions = clone(options);

    const value = (event.target as HTMLInputElement).value as
      | "left"
      | "right"
      | "center"
      | "justify";
    (nextOptions.series![0] as AgSankeySeriesOptions).node!.alignment = value;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="button-group" role="group" aria-label="Alignment">
            <input
              type="radio"
              id="alignment-left"
              name="alignment"
              defaultValue="left"
              defaultChecked
              onChange={(event) => alignmentChange(event)}
            />
            <label htmlFor="alignment-left">
              <code>'left'</code>
            </label>
            <input
              type="radio"
              id="alignment-right"
              name="alignment"
              defaultValue="right"
              onChange={(event) => alignmentChange(event)}
            />
            <label htmlFor="alignment-right">
              <code>'right'</code>
            </label>
            <input
              type="radio"
              id="alignment-center"
              name="alignment"
              defaultValue="center"
              onChange={(event) => alignmentChange(event)}
            />
            <label htmlFor="alignment-center">
              <code>'center'</code>
            </label>
            <input
              type="radio"
              id="alignment-justify"
              name="alignment"
              defaultValue="justify"
              onChange={(event) => alignmentChange(event)}
            />
            <label htmlFor="alignment-justify">
              <code>'justify'</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Alignment](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                alignment: 'left',
            },
        },
    ],
}
```

There are four values supported:

- `left` moves nodes as far left as possible.
- `right` moves nodes as far right as possible.
- `center` moves nodes as close to the centre as possible.
- `justify` moves nodes as far left as possible, except for the last nodes, which are pushed right.

### Vertical Alignment

The vertical placement of the nodes can be customised using the `verticalAlignment` property on `node`.

#### Vertical alignment

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFlowProportionChartOptions>({
    title: {
      text: "Company Revenue",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Employees", to: "Sales", size: 2 },
      { from: "Contractors", to: "Sales", size: 2 },
      { from: "Sales", to: "Revenue", size: 4 },
      { from: "Licenses", to: "Revenue", size: 4 },
      { from: "Revenue", to: "Cost of Sales", size: 1 },
      { from: "Revenue", to: "Profit", size: 7 },
      { from: "Profit", to: "Other Expenses", size: 2 },
      { from: "Profit", to: "Operational Profit", size: 5 },
      { from: "Operational Profit", to: "Shareholders", size: 3 },
      { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (USD millions)",
        node: {
          verticalAlignment: "center",
        },
      },
    ],
  });

  const verticalAlignChange = (event: Event) => {
    const nextOptions = clone(options);

    const verticalAlignment = (event.target as HTMLInputElement).value as
      | "top"
      | "bottom"
      | "center";
    (nextOptions.series![0] as AgSankeySeriesOptions).node!.verticalAlignment =
      verticalAlignment;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group"
            role="group"
            aria-label="Vertical Alignment"
          >
            <input
              type="radio"
              id="vertical-alignment-top"
              name="vertical-alignment"
              defaultValue="top"
              onChange={(event) => verticalAlignChange(event)}
            />
            <label htmlFor="vertical-alignment-top">
              <code>'top'</code>
            </label>
            <input
              type="radio"
              id="vertical-alignment-bottom"
              name="vertical-alignment"
              defaultValue="bottom"
              onChange={(event) => verticalAlignChange(event)}
            />
            <label htmlFor="vertical-alignment-bottom">
              <code>'bottom'</code>
            </label>
            <input
              type="radio"
              id="vertical-alignment-center"
              name="vertical-alignment"
              defaultValue="center"
              defaultChecked
              onChange={(event) => verticalAlignChange(event)}
            />
            <label htmlFor="vertical-alignment-center">
              <code>'center'</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Vertical alignment](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/vertical-alignment/)

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                verticalAlignment: 'top',
            },
        },
    ],
}
```

There are three values supported:

- `top` moves nodes as far up as possible.
- `bottom` moves nodes as far down as possible.
- `center` places the nodes in the middle and distributes evenly in each direction.

### Sorting

The order of the nodes can be customised using the `sort` property on `node`.

#### Sorting

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFlowProportionChartOptions>({
    title: {
      text: "Company Revenue",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Footwear", to: "North America", size: 2245 },
      { from: "Footwear", to: "Europe, Middle East & Africa", size: 1419 },
      { from: "Footwear", to: "Asia Pacific & Latin America", size: 879 },
      { from: "Footwear", to: "Greater China", size: 1022 },
      { from: "Apparel", to: "North America", size: 1405 },
      { from: "Apparel", to: "Asia Pacific & Latin America", size: 360 },
      { from: "Apparel", to: "Europe, Middle East & Africa", size: 794 },
      { from: "Apparel", to: "Greater China", size: 490 },
      { from: "Equipment", to: "North America", size: 132 },
      { from: "Equipment", to: "Europe, Middle East & Africa", size: 100 },
      { from: "Equipment", to: "Asia Pacific & Latin America", size: 59 },
      { from: "Equipment", to: "Greater China", size: 32 },
      { from: "North America", to: "NIKE Brand", size: 3782 },
      { from: "Europe, Middle East & Africa", to: "NIKE Brand", size: 2313 },
      { from: "Greater China", to: "NIKE Brand", size: 1544 },
      { from: "Asia Pacific & Latin America", to: "NIKE Brand", size: 1298 },
      { from: "Global Brand Divisions", to: "NIKE Brand", size: 9 },
      { from: "NIKE Brand", to: "Revenues", size: 8946 },
      { from: "Converse", to: "Revenues", size: 425 },
      { from: "Corporate", to: "Revenues", size: 3 },
      { from: "Revenues", to: "Cost of sales", size: 5269 },
      { from: "Revenues", to: "Gross profit", size: 4105 },
      {
        from: "Gross profit",
        to: "Selling and administrative expense",
        size: 3142,
      },
      { from: "Gross profit", to: "Interest expense", size: 14 },
      { from: "Gross profit", to: "Income before taxes", size: 949 },
      { from: "Other income", to: "Income before taxes", size: 48 },
      {
        from: "Selling and administrative expense",
        to: "Demand creation expense",
        size: 910,
      },
      {
        from: "Selling and administrative expense",
        to: "Operating overhead expense",
        size: 2232,
      },
      { from: "Income before taxes", to: "Tax expense", size: 150 },
      { from: "Income before taxes", to: "Net income", size: 847 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (USD millions)",
        node: {
          alignment: "center",
          sort: "auto",
        },
      },
    ],
  });

  const sortChange = (event: Event) => {
    const nextOptions = clone(options);

    const sort = (event.target as HTMLInputElement).value as
      | "data"
      | "ascending"
      | "descending"
      | "auto";
    (nextOptions.series![0] as AgSankeySeriesOptions).node!.sort = sort;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div className="button-group" role="group" aria-label="Sort">
            <input
              type="radio"
              id="sort-data"
              name="sort"
              defaultValue="data"
              onChange={(event) => sortChange(event)}
            />
            <label htmlFor="sort-data">
              <code>'data'</code>
            </label>
            <input
              type="radio"
              id="sort-ascending"
              name="sort"
              defaultValue="ascending"
              onChange={(event) => sortChange(event)}
            />
            <label htmlFor="sort-ascending">
              <code>'ascending'</code>
            </label>
            <input
              type="radio"
              id="sort-descending"
              name="sort"
              defaultValue="descending"
              onChange={(event) => sortChange(event)}
            />
            <label htmlFor="sort-descending">
              <code>'descending'</code>
            </label>
            <input
              type="radio"
              id="sort-auto"
              name="sort"
              defaultValue="auto"
              defaultChecked
              onChange={(event) => sortChange(event)}
            />
            <label htmlFor="sort-auto">
              <code>'auto'</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Sorting](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/sorting/)

There are three values supported:

- `data` sorts nodes in the same order as they first appear in the `data` array.
- `ascending` and `descending` sort nodes alphanumerically by their displayed labels.
- `auto` sorts nodes to reduce overlapping links and produce a cleaner layout.

## Label Placement

Labels can be placed to the left, right or centred over nodes using the `placement` property.

#### Label Placement

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgFlowProportionChartOptions,
  AgSankeySeriesOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";
import clone from "clone";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgFlowProportionChartOptions>({
    title: {
      text: "Company Revenue",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Employees", to: "Sales", size: 2 },
      { from: "Contractors", to: "Sales", size: 2 },
      { from: "Sales", to: "Revenue", size: 4 },
      { from: "Licenses", to: "Revenue", size: 4 },
      { from: "Revenue", to: "Cost of Sales", size: 1 },
      { from: "Revenue", to: "Profit", size: 7 },
      { from: "Profit", to: "Other Expenses", size: 2 },
      { from: "Profit", to: "Operational Profit", size: 5 },
      { from: "Operational Profit", to: "Shareholders", size: 3 },
      { from: "Operational Profit", to: "Employee Bonuses", size: 2 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (USD millions)",
        label: {
          placement: "right",
          edgePlacement: "outside",
        },
      },
    ],
  });

  const placementChange = (event: Event) => {
    const nextOptions = clone(options);

    const value = (event.target as HTMLInputElement).value as
      | "left"
      | "right"
      | "center";
    (nextOptions.series![0] as AgSankeySeriesOptions).label!.placement = value;

    setOptions(nextOptions);
  };

  const edgePlacementChange = (event: Event) => {
    const nextOptions = clone(options);

    const value = (event.target as HTMLInputElement).value;
    (nextOptions.series![0] as AgSankeySeriesOptions).label!.edgePlacement =
      value === "default" ? undefined : (value as "inside" | "outside");

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span> Placement: </span>
          <div
            className="button-group gap-right"
            role="group"
            aria-label="Placement"
          >
            <input
              type="radio"
              id="placement-left"
              name="placement"
              defaultValue="left"
              onChange={(event) => placementChange(event)}
            />
            <label htmlFor="placement-left">
              <code>'left'</code>
            </label>
            <input
              type="radio"
              id="placement-right"
              name="placement"
              defaultValue="right"
              defaultChecked
              onChange={(event) => placementChange(event)}
            />
            <label htmlFor="placement-right">
              <code>'right'</code>
            </label>
            <input
              type="radio"
              id="placement-center"
              name="placement"
              defaultValue="center"
              onChange={(event) => placementChange(event)}
            />
            <label htmlFor="placement-center">
              <code>'center'</code>
            </label>
          </div>
          <span> Edge Placement: </span>
          <div
            className="button-group"
            role="group"
            aria-label="Edge Placement"
          >
            <input
              type="radio"
              id="edge-placement-outside"
              name="edge-placement"
              defaultValue="outside"
              defaultChecked
              onChange={(event) => edgePlacementChange(event)}
            />
            <label htmlFor="edge-placement-outside">
              <code>'outside'</code>
            </label>
            <input
              type="radio"
              id="edge-placement-inside"
              name="edge-placement"
              defaultValue="inside"
              onChange={(event) => edgePlacementChange(event)}
            />
            <label htmlFor="edge-placement-inside">
              <code>'inside'</code>
            </label>
            <input
              type="radio"
              id="edge-placement-default"
              name="edge-placement"
              defaultValue="default"
              onChange={(event) => edgePlacementChange(event)}
            />
            <label htmlFor="edge-placement-default">
              <code>undefined</code>
            </label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Label Placement](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/label-placement/)

The optional `edgePlacement` property sets the first and last node labels to `'inside'` or `'outside'`, defaulting to the `placement` value if unspecified.

## Customisation

### Node Style

#### Node Style

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "UK Power Generation",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Wind", to: "Renewables", size: 79 },
      { from: "Nuclear", to: "Renewables", size: 38 },
      { from: "Biomass", to: "Renewables", size: 14 },
      { from: "Solar", to: "Renewables", size: 13 },
      { from: "Hydro", to: "Renewables", size: 3 },
      { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
      { from: "Coal", to: "Fossil Fuels", size: 3 },
      { from: "Imports", to: "Total", size: 33 },
      { from: "Fossil Fuels", to: "Total", size: 89 },
      { from: "Renewables", to: "Total", size: 147 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (GWh)",
        node: {
          fill: "#34495e",
          stroke: "#2c3e50",
          strokeWidth: 2,
        },
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Node Style](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/node-style/)

The styling of all nodes can be customised using the `node` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            node: {
                fill: '#34495e',
                stroke: '#2c3e50',
                strokeWidth: 2,
            },
        },
    ],
}
```

### Link Style

#### Link Style

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  AnimationModule,
  ContextMenuModule,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  SankeySeriesModule,
} from "ag-charts-enterprise";

ModuleRegistry.registerModules([
  AnimationModule,
  CrosshairModule,
  LegendModule,
  SankeySeriesModule,
  ContextMenuModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions>({
    title: {
      text: "UK Power Generation",
    },
    subtitle: {
      text: "2023",
    },
    data: [
      { from: "Wind", to: "Renewables", size: 79 },
      { from: "Nuclear", to: "Renewables", size: 38 },
      { from: "Biomass", to: "Renewables", size: 14 },
      { from: "Solar", to: "Renewables", size: 13 },
      { from: "Hydro", to: "Renewables", size: 3 },
      { from: "Natural Gas", to: "Fossil Fuels", size: 86 },
      { from: "Coal", to: "Fossil Fuels", size: 3 },
      { from: "Imports", to: "Total", size: 33 },
      { from: "Fossil Fuels", to: "Total", size: 89 },
      { from: "Renewables", to: "Total", size: 147 },
    ],
    series: [
      {
        type: "sankey",
        fromKey: "from",
        toKey: "to",
        sizeKey: "size",
        sizeName: "Total (GWh)",
        link: {
          fill: "#34495e",
          fillOpacity: 0.25,
          stroke: "#2c3e50",
          strokeWidth: 1,
          strokeOpacity: 0.25,
        },
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Link Style](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/sankey-series/examples/link-style/)

The styling of all links can be customised using the `link` property.

```js
{
    series: [
        {
            type: 'sankey',
            fromKey: 'from',
            toKey: 'to',
            sizeKey: 'size',
            link: {
                fill: '#34495e',
                fillOpacity: 0.25,
                stroke: '#2c3e50',
                strokeWidth: 1,
                strokeOpacity: 0.25,
            },
        },
    ],
}
```

## Sankey Chart Examples

See more Sankey Chart examples in the [AG Charts Gallery](https://www.ag-grid.com/charts/archive/14.2.0/gallery/#sankey).

- [Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey/)
- [Customised Sankey Chart Example](https://www.ag-grid.com/charts/archive/14.2.0/gallery/sankey-customisation/)

## API Reference

#### Sankey Series

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| type (required) | 'sankey' |  | Configuration for the Sankey Series. |
| getItemId | Function |  | A callback to provide a stable identifier for each node, exposed as `itemId` in events and active state.  The returned identifier must be unique across nodes and links, which share one `itemId` namespace (links default to `link-<index>`).  If not supplied, the node name is used as its identifier. |
| id | string | auto-generated value | Primary identifier for the series. This is provided as `seriesId` in user callbacks to differentiate multiple series. Auto-generated ids are subject to future change without warning, if your callbacks need to vary behaviour by series please supply your own unique `id` value. |
| context | ContextDefault |  | Context object to use in callbacks. |
| data | DatumDefault[] |  | The data to use when rendering the series. If this is not supplied, data must be set on the chart instead. |
| visible | boolean |  | Whether to display the series. |
| cursor | string |  | The cursor to use for hovered markers. This config is identical to the CSS `cursor` property. |
| highlight | AgHighlightOptions |  | Configuration for highlighting when a series or legend item is hovered over. |
| highlight.enabled | boolean |  | Set to `false` to disable highlighting. |
| highlight.highlightedItem | AgHighlightStyleOptions |  | Options for the highlighted item. |
| highlight.highlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.highlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.highlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.highlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.highlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.highlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.highlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.highlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| highlight.unhighlightedItem | AgHighlightStyleOptions |  | Options for the un-highlighted items when there is an active highlight. |
| highlight.unhighlightedItem.opacity | Opacity |  | The opacity of the whole series (line, fill, labels and markers, if any) |
| highlight.unhighlightedItem.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| highlight.unhighlightedItem.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| highlight.unhighlightedItem.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| highlight.unhighlightedItem.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| highlight.unhighlightedItem.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| highlight.unhighlightedItem.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| highlight.unhighlightedItem.fillOpacity | Opacity |  | The opacity of the fill colour. |
| nodeClickRange | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a node that a click triggers the listener. |
| showInLegend | boolean |  | Whether to include the series in the legend. |
| listeners | AgSeriesListeners |  | A map of event names to event listeners. |
| listeners.seriesNodeClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is clicked. |
| listeners.seriesNodeDoubleClick | Listener |  | The listener to call when a node (marker, column, bar, tile or a pie sector) in the series is double-clicked. |
| fromKey | string |  | The key containing the start node of each link. |
| toKey | string |  | The key containing the end node of each link. |
| sizeKey | string |  | The key containing the size of each link. |
| sizeName | string |  | A human-readable description of the size values. If supplied, this will be shown in the default tooltip and passed to the tooltip renderer as one of the parameters. |
| label | AgSankeySeriesLabelOptions |  | Options for the label for each node. |
| label.spacing | PixelSize |  | Spacing between a node and its label. |
| label.placement | 'left' \| 'right' \| 'center' |  | Placement of a label relative to its node. |
| label.edgePlacement | 'inside' \| 'outside' |  | Placement of an edge label relative to its node. |
| label.formatter | RichFormatter |  | A custom formatting function used to convert data values into text for display by labels. |
| label.format | string |  | Format string used when rendering labels. |
| label.itemStyler | Styler |  | Function used to style individual datum labels. |
| label.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.color | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for text elements. A colour string, or a theme-colour reference object. |
| label.fontSize | FontSize |  | The size of the font in pixels for text elements. |
| label.fontFamily | FontFamily |  | The font family for text elements. |
| label.fontStyle | FontStyle |  | The style to use for text elements. |
| label.fontWeight | FontWeight |  | The font weight to use for text elements. |
| label.border | BorderOptions |  | Stroke options for the box border. |
| label.border.enabled | boolean |  | Whether the associated elements and properties should be used in the chart. |
| label.border.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| label.border.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| label.border.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| label.cornerRadius | PixelSize |  | Apply rounded corners to the label box. |
| label.padding | PixelSize \| PaddingOptions |  | Distance between the label text and the border. A number applies uniform padding; an object sets each side. |
| label.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| label.fillOpacity | Opacity |  | The opacity of the fill colour. |
| fills | Array<CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill> |  | The colours to cycle through for the fills of the nodes and links. An array of colour strings, or fill objects for gradients, patterns, or images. |
| strokes | CssColor[] |  | The colours to cycle through for the strokes of the nodes and links. |
| link | AgSankeySeriesLinkOptions |  | Options for the links. |
| link.itemStyler | Styler |  | Function used to return formatting for individual links, based on the given parameters. |
| link.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| link.fillOpacity | Opacity |  | The opacity of the fill colour. |
| link.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| link.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| link.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| link.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| link.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| node | AgSankeySeriesNodeOptions |  | Options for the nodes. |
| node.spacing | PixelSize | 20 | Spacing between the nodes. |
| node.minSpacing | PixelSize | 0 | Minimum spacing between the nodes when the series area is reduced in height. |
| node.width | PixelSize | 1 | Width of the nodes. |
| node.cornerRadius | PixelSize | 0 | Rounded corner radius applied to each node, in pixels. |
| node.alignment | 'left' \| 'right' \| 'center' \| 'justify' | 'justify' | Alignment of the nodes. |
| node.verticalAlignment | 'top' \| 'bottom' \| 'center' | 'center' | Vertical alignment of the nodes. |
| node.sort | 'data' \| 'ascending' \| 'descending' \| 'auto' | 'auto' | Sorting method of the nodes. |
| node.itemStyler | Styler |  | Function used to return formatting for individual nodes, based on the given parameters. |
| node.fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| node.fillOpacity | Opacity |  | The opacity of the fill colour. |
| node.stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| node.strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| node.strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| node.lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| node.lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |
| tooltip | AgSeriesTooltip |  | Series-specific tooltip configuration. |
| tooltip.enabled | boolean |  | Whether to show tooltips when the series are hovered over. |
| tooltip.showArrow | boolean |  | The tooltip arrow is displayed by default, unless the container restricts it or a position offset is provided. To always display the arrow, set `showArrow` to `true`. To remove the arrow, set `showArrow` to `false`. |
| tooltip.range | PixelSize \| 'exact' \| 'nearest' \| 'area' |  | Range from a point that triggers the tooltip to show. Each series type uses its own default; typically this is `'nearest'` for marker-based series and `'exact'` for shape-based series. |
| tooltip.position | AgTooltipPositionOptions |  | The position of the tooltip. Each series type uses its own default; typically this is `'node'` for marker-based series and `'pointer'` for shape-based series. |
| tooltip.position.anchorTo | AgTooltipAnchorTo |  | The element or point to position the tooltip relative to. |
| tooltip.position.placement | AgTooltipPlacement \| AgTooltipPlacement[] |  | The positioning of the tooltip in relation to the element it's anchored to. Multiple values can be provided as a fallback mechanism for the case the tooltip does not fit inside the chart. |
| tooltip.position.xOffset | PixelSize |  | The horizontal offset in pixels for the position of the tooltip. |
| tooltip.position.yOffset | PixelSize |  | The vertical offset in pixels for the position of the tooltip. |
| tooltip.position.offset | PixelSize |  | The distance in pixels between the tooltip and its anchor point, applied in the placement direction.  Default: `12` (`0` when `anchorTo` is `'chart'`). |
| tooltip.interaction | AgSeriesTooltipInteraction |  | Configuration for tooltip interaction. |
| tooltip.interaction.enabled (required) | boolean |  | Set to `true` to keep the tooltip open when the mouse is hovering over it, and enable clicking tooltip text |
| tooltip.renderer | Renderer |  | Function used to create the content for tooltips. |
